#!/bin/bash

# Install some custom configuratation for odroid x2 board

# TODO manually
# * change root password
#     passwd
# * add private ssh key
#     ssh-copy-id odroid@x2

# Stop on first failure
set -e

# Show each command
set -x

# Url to common configuratian and executables
project_setup_common_url=https://gitlab.com/krystian.wojtas/setup-common-user/-/archive/master/setup-common-user-master.tar

# Go to script directory
cd "$(realpath "$(dirname "$0")")"

# Install common user configuration files
\
`# Run command as target user` \
su \
    "$SUDO_USER" \
    --command \
    "
        `# Download newest archive` \
        curl \
            --silent \
            '$project_setup_common_url' |
        \
        `# Unpack archive and overwrite any previous configs` \
        tar \
            --extract \
            \
            `# Ommit internal top level directory with repository name` \
            --strip-components=1 \
            \
            `# Unpack to home directory of target user` \
            --directory '$HOME' \
    "

# Install user configuration files
`# Create local archive with needed directories` \
tar --create --directory home . |
`# Unpack archive to overwrite default configs with custom ones` \
tar --extract --directory "$HOME"

# Fix ssh config permissions
chmod 600 "$HOME"/.ssh/config

# Install some extra software packages
# apt-get update
apt-get \
    install \
        --yes \
        \
        tftp \
        tftpd \
        tig \
        tmux \
        tree \
        zsh \

# Set zsh as default shell for target user
chsh --shell /bin/zsh "$SUDO_USER"

# Openwrt tftp configuration
# TFTP from server 192.168.0.66; our IP address is 192.168.0.86
# Filename 'wdr3600v1_tp_recovery.bin'.

# # Prepare tftp boot directory
# mkdir /tftpboot
# chmod -R 777 /tftpboot
# chown -R nobody /tftpboot

# # Restart the xinetd service to start tftp
# sudo service xinetd restart
